/*
 Sia GAB l’insieme dei grafi orientati con nodi etichettai su generico tipo A ed archi etichettati 
 su generico tipo B, con le seguenti operazioni:
	addN ln: aggiunge i nodi della lista ln non gi\`a contenuti nel grafo
	addE le: aggiunge gli archi della lista le non gi\`a contenuti in g. Pu\`o solevare eccezioni.
	removeN n: rimuove il nodo n e tutti gli archi entranti ed uscenti da n. Pu\`o sol. eccez.
	removeE e: rimuove l'arco e. Pu\'o sollevare eccezioni.
     isNin n: calcola vero sse n \`e un nodo del grafo
	isEin e : calcola vero sse e \`e un arco del grafo
	nodes: calcola la lista di tutti i nodi del grafo
	outN n: calcola la lista dei nodi uscenti da n. Pu\`o sollevare eccez.
 In aggiunta, ad un appropriato costruttore per grafi vuoti ma di fissato tipo A e B, e gli usuali
 additionals.

 Si assuma già definita una classe Java, API, ed un ADT Graph, per un Tipo Astratto di valori modi-
 ficabili GAB con le operazioni descritte sopra.
 Tutte le classi sono parte di un package, GraphPack, contenente anche classi per nodi, Node, e per
 archi, Edge. Inoltre si usino Vector di tipo appropriato per le liste di valori.
 
 (a)	Si mostri una definizione approprata per API.
 (b)	Si definisca una sottoclasse GraphK per grafi aventi nodi con outdegree massimo fissato al mo-
     mento della costruzione.
 */

/* Fuori testo:
 Prologo: Creare 4 file:
 1 per la API API<A>
 1 per la classe Queue<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */

package GraphPack;

//Non cloneable, structured, IMMUTABLE values
public interface EdgeAPI<A,B> {
    public Node<A> getSource();
    public Node<A> getTarget();
    public B getLabel();
    public boolean equals(EdgeAPI<A,B> E);// equivalenza Strutturale
    public String toString();
    public String toStringHash();
}


